tests: add `cc.skip` to skip the C compilation of some programs
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export NIT_TESTING=true
23
24 unset NIT_DIR
25
26 # Get the first Java lib available
27 shopt -s nullglob
28 paths=`echo /usr/lib/jvm/*/`
29 paths=($paths)
30 JAVA_HOME=${paths[0]}
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
33 paths=($paths)
34 JNI_LIB_PATH=${paths[0]}
35 shopt -u nullglob
36
37 usage()
38 {
39 e=`basename "$0"`
40 cat<<END
41 Usage: $e [options] modulenames
42 -o option Pass option to the engine
43 -v Verbose (show tests steps)
44 -h This help
45 --tap Produce TAP output
46 --engine Use a specific engine (default=nitg)
47 --noskip Do not skip a test even if the .skip file matches
48 --[no]soso Force enable (or disable) SOSO
49 END
50 }
51
52 # $1 is the pattern of the test
53 # $2 is the file to compare to
54 # the result is:
55 # 0: if the file to compare to do not exists
56 # 1: if the file match
57 # 2: if the file match with soso
58 # 3: if the file do not match
59 function compare_to_result()
60 {
61 local pattern="$1"
62 local sav="$2"
63 if [ ! -r "$sav" ]; then return 0; fi
64 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
65 if [ "$?" == 0 ]; then
66 return 1
67 fi
68 [ -z "$soso" ] && return 3
69 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
70 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
71 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
72 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
73 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
74 if [ "$?" == 0 ]; then
75 return 2
76 else
77 return 3
78 fi
79 }
80
81 # As argument: the pattern used for the file
82 function process_result()
83 {
84 ((tapcount=tapcount+1))
85 # Result
86 pattern=$1
87 description=$2
88 pack=$3
89 SAV=""
90 NSAV=""
91 FIXME=""
92 NFIXME=""
93 SOSO=""
94 NSOSO=""
95 SOSOF=""
96 NSOSOF=""
97 OLD=""
98 LIST=""
99 FIRST=""
100 echo >>$xml "<testcase classname='$pack' name='$description'>"
101 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
102 for savdir in $savdirs; do
103 sav=$savdir/$pattern.res
104 compare_to_result "$pattern" "$sav"
105
106 case "$? $sav" in
107 0*)
108 continue;; # no file
109 1*/fixme/*)
110 OLD="$LIST"
111 FIXME="$sav"
112 ;;
113 1*)
114 OLD="$LIST"
115 SAV="$sav"
116 ;;
117 2*/fixme/*)
118 SOSOF="$sav" ;;
119 2*)
120 SOSO="$sav" ;;
121 3*/fixme/*)
122 if [ -z "$FIRST" ]; then
123 NFIXME="$sav"
124 FIRST="$sav"
125 fi
126 ;;
127 3*)
128 if [ -z "$FIRST" ]; then
129 NSAV="$sav"
130 FIRST="$sav"
131 fi
132 ;;
133 esac
134 LIST="$LIST $sav"
135 done
136 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
137 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
138 NYI="$?"
139 if [ -n "$SAV" ]; then
140 if [ -n "$tap" ]; then
141 echo "ok - $description"
142 elif [ -n "$OLD" ]; then
143 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
144 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
145 remains="$remains $OLD"
146 else
147 echo "[ok] out/$pattern.res $SAV"
148 fi
149 ok="$ok $pattern"
150 elif [ -n "$FIXME" ]; then
151 if [ -n "$tap" ]; then
152 echo "not ok - $description # TODO expected failure"
153 elif [ -n "$OLD" ]; then
154 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
155 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
156 remains="$remains $OLD"
157 else
158 echo "[fixme] out/$pattern.res $FIXME"
159 echo >>$xml "<skipped/>"
160 fi
161 todos="$todos $pattern"
162 elif [ -n "$SOSO" ]; then
163 if [ -n "$tap" ]; then
164 echo "ok - $description # SOSO"
165 else
166 echo "[soso] out/$pattern.res $SOSO"
167 fi
168 ok="$ok $pattern"
169 elif [ "x$NYI" = "x0" ]; then
170 if [ -n "$tap" ]; then
171 echo "not ok - $description # TODO not yet implemented"
172 else
173 echo "[todo] out/$pattern.res -> not yet implemented"
174 echo >>$xml "<skipped/>"
175 fi
176 todos="$todos $pattern"
177 elif [ -n "$SOSOF" ]; then
178 if [ -n "$tap" ]; then
179 echo "not ok - $description # TODO SOSO expected failure"
180 else
181 echo "[fixme soso] out/$pattern.res $SOSOF"
182 echo >>$xml "<skipped/>"
183 fi
184 todos="$todos $pattern"
185 elif [ -n "$NSAV" ]; then
186 if [ -n "$tap" ]; then
187 echo "not ok - $description"
188 else
189 echo "[======= fail out/$pattern.res $NSAV =======]"
190 fi
191 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
192 echo >>$xml "<system-out><![CDATA["
193 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
194 echo >>$xml "]]></system-out>"
195 nok="$nok $pattern"
196 echo "$ii" >> "$ERRLIST"
197 elif [ -n "$NFIXME" ]; then
198 if [ -n "$tap" ]; then
199 echo "not ok - $description"
200 else
201 echo "[======= changed out/$pattern.res $NFIXME ======]"
202 fi
203 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
204 echo >>$xml "<system-out><![CDATA["
205 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
206 echo >>$xml "]]></system-out>"
207 nok="$nok $pattern"
208 echo "$ii" >> "$ERRLIST"
209 else
210 if [ -n "$tap" ]; then
211 echo "ok - $description # skip no sav"
212 else
213 echo "[=== no sav ===] out/$pattern.res"
214 fi
215 echo >>$xml "<skipped/>"
216 echo >>$xml "<system-out><![CDATA["
217 cat -v >>$xml out/$pattern.res
218 echo >>$xml "]]></system-out>"
219 nos="$nos $pattern"
220 fi
221 if test -s out/$pattern.cmp.err; then
222 echo >>$xml "<system-err><![CDATA["
223 cat -v >>$xml out/$pattern.cmp.err
224 echo >>$xml "]]></system-err>"
225 fi
226 echo >>$xml "</testcase>"
227 }
228
229 need_skip()
230 {
231 test "$noskip" = true && return 1
232 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
233 ((tapcount=tapcount+1))
234 if [ -n "$tap" ]; then
235 echo "ok - $2 # skip"
236 else
237 echo "=> $2: [skip]"
238 fi
239 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
240 return 0
241 fi
242 if test $engine = niti && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
243 ((tapcount=tapcount+1))
244 if [ -n "$tap" ]; then
245 echo "ok - $2 # skip"
246 else
247 echo "=> $2: [skip exec]"
248 fi
249 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
250 return 0
251 fi
252 return 1
253 }
254
255 skip_exec()
256 {
257 test "$noskip" = true && return 1
258 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
259 echo -n "_ "
260 return 0
261 fi
262 return 1
263 }
264
265 skip_cc()
266 {
267 test "$noskip" = true && return 1
268 if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
269 return 0
270 fi
271 return 1
272 }
273
274 find_nitc()
275 {
276 ((tapcount=tapcount+1))
277 name="$enginebinname"
278 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
279 if [[ "x$recent" == "x" ]]; then
280 if [ -n "$tap" ]; then
281 echo "not ok - find binary for $engine"
282 echo "Bail out! Could not find binary for engine $engine, aborting"
283 else
284 echo "Could not find binary for engine $engine, aborting"
285 fi
286 exit 1
287 fi
288 if [ -n "$tap" ]; then
289 echo "ok - find binary for $engine: $recent $OPT"
290 else
291 echo "Find binary for engine $engine: $recent $OPT"
292 fi
293 NITC=$recent
294 }
295
296 verbose=false
297 stop=false
298 tapcount=0
299 engine=nitg
300 noskip=
301 while [ $stop = false ]; do
302 case $1 in
303 -o) OPT="$OPT $2"; shift; shift;;
304 -v) verbose=true; shift;;
305 -h) usage; exit;;
306 --tap) tap=true; shift;;
307 --engine) engine="$2"; shift; shift;;
308 --noskip) noskip=true; shift;;
309 --soso) soso=true; shift;;
310 --nososo) nososo=true; shift;;
311 *) stop=true
312 esac
313 done
314 enginebinname=$engine
315 case $engine in
316 nitg)
317 engine=nitg-s;
318 enginebinname=nitg;
319 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
320 OPT="--separate $OPT"
321 ;;
322 nitg-s)
323 enginebinname=nitg;
324 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
325 OPT="--separate $OPT"
326 ;;
327 nitg-e)
328 enginebinname=nitg;
329 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
330 OPT="--erasure $OPT"
331 ;;
332 nitg-g)
333 enginebinname=nitg;
334 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
335 OPT="--global $OPT"
336 ;;
337 nit)
338 engine=niti
339 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
340 ;;
341 niti)
342 enginebinname=nit
343 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
344 ;;
345 nitc)
346 echo "disabled engine $engine"
347 exit 0
348 ;;
349 *)
350 echo "unknown engine $engine"
351 exit 1
352 ;;
353 esac
354
355 # The default nitc compiler
356 [ -z "$NITC" ] && find_nitc
357
358 # Set NIT_DIR if needed
359 [ -z "$NIT_DIR" ] && export NIT_DIR=..
360
361 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
362 TIMEOUT="timelimit -t 600"
363 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
364 TIMEOUT="timeout 600s"
365 else
366 echo "No timelimit or timeout command detected. Tests may hang :("
367 fi
368
369 # Mark to distinguish files among tests
370 # MARK=
371
372 # File where error tests are outputed
373 # Old ERRLIST is backuped
374 ERRLIST=${ERRLIST:-errlist}
375 ERRLIST_TARGET=$ERRLIST
376
377 if [ $# = 0 ]; then
378 usage;
379 exit
380 fi
381
382 # Initiate new ERRLIST
383 if [ "x$ERRLIST" = "x" ]; then
384 ERRLIST=/dev=null
385 else
386 ERRLIST=$ERRLIST.tmp
387 > "$ERRLIST"
388 fi
389
390 ok=""
391 nok=""
392 todos=""
393 xml="tests-$engine.xml"
394 echo >$xml "<testsuites><testsuite>"
395
396 # CLEAN the out directory
397 rm -rf out/ 2>/dev/null
398 mkdir out 2>/dev/null
399
400 for ii in "$@"; do
401 if [ ! -f $ii ]; then
402 echo "File '$ii' does not exist."
403 continue
404 fi
405 f=`basename "$ii" .nit`
406
407 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
408
409 # Sould we skip the file for this engine?
410 need_skip $f $f $pack && continue
411
412 tmp=${ii/../AA}
413 if [ "x$tmp" = "x$ii" ]; then
414 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
415 else
416 includes="-I alt"
417 fi
418
419 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
420 bf=`basename $i .nit`
421 ff="out/$bf"
422
423 # Sould we skip the alternative for this engine?
424 need_skip $bf $bf $pack && continue
425
426 test -z "$tap" && echo -n "=> $bf: "
427
428 if [ -f "$f.inputs" ]; then
429 inputs="$f.inputs"
430 else
431 inputs=/dev/null
432 fi
433
434 if [ "$engine" = "niti" ]; then
435 cat > "./$ff.bin" <<END
436 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
437 END
438 chmod +x "./$ff.bin"
439 > "$ff.cmp.err"
440 > "$ff.compile.log"
441 ERR=0
442 else
443 if skip_cc "$bf"; then
444 nocc="--no-cc"
445 else
446 nocc=
447 fi
448 # Compile
449 if [ "x$verbose" = "xtrue" ]; then
450 echo ""
451 echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes" $nocc
452 fi
453 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
454 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes $nocc 2> "$ff.cmp.err" > "$ff.compile.log"
455 ERR=$?
456 if [ "x$verbose" = "xtrue" ]; then
457 cat "$ff.compile.log"
458 cat >&2 "$ff.cmp.err"
459 fi
460 fi
461 if [ "$ERR" != 0 ]; then
462 test -z "$tap" && echo -n "! "
463 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
464 process_result $bf $bf $pack
465 elif skip_exec "$bf"; then
466 # No exec
467 > "$ff.res"
468 process_result $bf $bf $pack
469 elif [ -n "$nocc" ]; then
470 # not compiled
471 test -z "$tap" && echo -n "nocc "
472 > "$ff.res"
473 process_result $bf $bf $pack
474 elif [ -x "./$ff.bin" ]; then
475 test -z "$tap" && echo -n ". "
476 # Execute
477 args=""
478 if [ "x$verbose" = "xtrue" ]; then
479 echo ""
480 echo "NIT_NO_STACK=1 ./$ff.bin" $args
481 fi
482 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
483 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
484 if [ "x$verbose" = "xtrue" ]; then
485 cat "$ff.res"
486 cat >&2 "$ff.err"
487 fi
488 if [ -f "$ff.write" ]; then
489 cat "$ff.write" >> "$ff.res"
490 elif [ -d "$ff.write" ]; then
491 LANG=C /bin/ls -F $ff.write >> "$ff.res"
492 fi
493 cp "$ff.res" "$ff.res2"
494 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
495 process_result $bf $bf $pack
496
497 if [ -f "$f.args" ]; then
498 fargs=$f.args
499 cptr=0
500 while read line; do
501 ((cptr=cptr+1))
502 args="$line"
503 bff=$bf"_args"$cptr
504 fff=$ff"_args"$cptr
505 name="$bf args $cptr"
506
507 # Sould we skip the input for this engine?
508 need_skip $bff " $name" $pack && continue
509
510 # use a specific inputs file, if required
511 if [ -f "$bff.inputs" ]; then
512 ffinputs="$bff.inputs"
513 else
514 ffinputs=$inputs
515 fi
516
517 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
518 if [ "x$verbose" = "xtrue" ]; then
519 echo ""
520 echo "NIT_NO_STACK=1 ./$ff.bin" $args
521 fi
522 test -z "$tap" && echo -n "==> $name "
523 echo "./$ff.bin $args" > "./$fff.bin"
524 chmod +x "./$fff.bin"
525 WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
526 if [ "x$verbose" = "xtrue" ]; then
527 cat "$fff.res"
528 cat >&2 "$fff.err"
529 fi
530 if [ -f "$fff.write" ]; then
531 cat "$fff.write" >> "$fff.res"
532 elif [ -d "$fff.write" ]; then
533 LANG=C /bin/ls -F $fff.write >> "$fff.res"
534 fi
535 if [ -s "$fff.err" ]; then
536 cp "$fff.res" "$fff.res2"
537 cat "$fff.err" "$fff.res2" > "$fff.res"
538 fi
539 process_result $bff " $name" $pack
540 done < $fargs
541 fi
542 elif [ -f "./$ff.bin" ]; then
543 echo "Not executable (platform?)" > "$ff.res"
544 process_result $bf "$bf" $pack
545 else
546 test -z "$tap" && echo -n "! "
547 cat "$ff.cmp.err" > "$ff.res"
548 echo "Compilation error" > "$ff.res"
549 process_result $bf "$bf" $pack
550 fi
551 done
552 done
553
554 if [ -n "$tap" ]; then
555 echo "1..$tapcount"
556 echo "# ok:" `echo $ok | wc -w`
557 echo "# not ok:" `echo $nok | wc -w`
558 echo "# no sav:" `echo $nos | wc -w`
559 echo "# todo/fixme:" `echo $todos | wc -w`
560 echo "# of sav that remains:" `echo $remains | wc -w`
561 exit
562 fi
563
564 echo "engine: $engine ($enginebinname $OPT)"
565 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
566
567 if [ -n "$nok" ]; then
568 echo "fail: $nok"
569 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
570 fi
571 if [ -n "$nos" ]; then
572 echo "no sav: $nos"
573 fi
574 if [ -n "$todos" ]; then
575 echo "todo/fixme: $todos"
576 fi
577 if [ -n "$remains" ]; then
578 echo "sav that remains: $remains"
579 fi
580
581 # write $ERRLIST
582 if [ "x$ERRLIST" != "x" ]; then
583 if [ -x "$ERRLIST_TARGET" ]; then
584 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
585 fi
586 mv $ERRLIST $ERRLIST_TARGET
587 fi
588
589 echo >>$xml "</testsuite></testsuites>"
590
591 if [ -n "$nok" ]; then
592 exit 1
593 else
594 exit 0
595 fi